clear all
close all
clc

Brand=2;  %Brand=1-->Flexiforce
          %Brand=2-->Interlink

switch Brand
    case 1
load('ParmsFlexiForce.mat');
Fm=15;
Afsr=pi*(0.0077/2)^2;
vth=0.07;
    case 2
load('ParmsInterlink.mat');
Fm=5;
Afsr=pi*(0.0138/2)^2;
vth=0.143;
end

e=1.60217662e-19;
m=9.10938356e-31;
h=6.62607004e-34;
c1=sqrt(2*m);
e2=e^2;
e3=e^3;
h2=h^2;

A0=Parms(1)*1e-18; 
s0=Parms(2)*1e-9;
k1=Parms(3)*1e6;
Va=Parms(4);
A1=Parms(5)*1e-18;
A2=Parms(6);
Rpar=Parms(7);
Rc0=Parms(8);
alfa=Parms(9);

delay=2;
fulltime=3600;
ts=20;

B_Afsr=200000;
Area=A0+A1*(B_Afsr)^A2;

k2=10*k1;
b2=5000*k1;
b1=72000*k1;

t=1:ts:fulltime-1;

force=B_Afsr.*[zeros(1,delay) ones(1,(fulltime-delay-1))];

x=1;

syms Ip Im Ig

tic

    for i=delay+1:length(t)
    
    Ip_solved(i-delay)=double(vpasolve(Ip==((((3*(Area)*e2.*sqrt(2*m*Va*e))./...
     (2*h2*...
     s0*(1-force(i)*((1/k1)+(t(i)/b1)+(1/k2)*(1-exp(-k2*t(i)/b2))))...
     ))...
     .*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ip).*...
     exp(-(4/h)*pi*s0*(1-force(i)*((1/k1)+(t(i)/b1)+(1/k2)*(1-exp(-k2*t(i)/b2))))...
     .*sqrt(2*m*Va*e)))),Ip));  % Eq. simmons pequea
     
    end 

    
    for i=delay+1:length(t)
        
        Im_solved(i-delay)=real(double(vpasolve(Im==(((e*Area)./...
        (2*pi*h*(s0^2).*(1-force(i).*((1/k1)+(t(i)/b1)+(1/k2).*(1-exp(-k2*t(i)/b2)))).^2)).*...
        ((Va*e-(e*(x-(Rpar+Rc0/((force(i)).^(alfa))).*Im)/2)).*...
        exp(-(4*pi*c1*s0.*(1-force(i).*((1/k1)+(t(i)/b1)+(1/k2).*(1-exp(-k2*t(i)/b2)))).*...
        ((Va*e-(e*(x-(Rpar+Rc0/((force(i)).^(alfa))).*Im)/2))).^(1/2)/h))-...
        ((Va*e+(e*(x-(Rpar+Rc0/((force(i)).^(alfa))).*Im)/2)).*...
        exp(-(4*pi*c1*s0.*(1-force(i).*((1/k1)+(t(i)/b1)+(1/k2).*(1-exp(-k2*t(i)/b2)))).*...
        ((Va*e+(e*(x-(Rpar+Rc0/((force(i)).^(alfa))).*Im)/2))).^(1/2)/h))))),Im))); % Eq. Simmons Intermedia
    end

   
    for i=delay+1:length(t)

    Ig_solved(i-delay)=double(vpasolve(Ig==(Area*...
    ((2.2*e3*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ig).^2)/...
    (8*pi*h*Va*e*(s0^2)*(1-force(i)*((1/k1)+(t(i)/b1)+(1/k2)*(1-exp(-k2*t(i)/b2))))^2)).*...
    (exp(-((8*pi*s0*(1-force(i)*((1/k1)+(t(i)/b1)+(1/k2)*(1-exp(-k2*t(i)/b2))))*c1*((Va*e)^(3/2)))/...
    (2.96*h*e*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ig))))...
    -(1+((2.*e.*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ig))/(Va*e))).*...
    exp(-((8*pi*s0*(1-force(i)*((1/k1)+(t(i)/b1)+(1/k2)*(1-exp(-k2*t(i)/b2))))*c1*((Va*e)^(3/2)).*...
    (1+((2*e*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ig))./(Va*e)))^(1/2))./...
    (2.96*h*e*(x-(Rpar+Rc0/((force(i))^(alfa)))*Ig)))))),Ig)); % Eq. Simmons grande

    end

toc

I=[Ip_solved' Im_solved' Ig_solved'];

[flg,chk,K]=check_simmons(x,force,I,Rpar,Rc0,alfa,Afsr,Va,vth,delay);

switch flg
    case 'Small'
        I_=I(:,1);
    case 'Medium'
        I_=I(:,2);
    case 'Large'
        I_=I(:,3);
end

drift=100*(I_-I_(1))/I_(1);

plot(t(delay+1:end),drift,'LineWidth',2)
xlabel('Time [s]')
ylabel('drift [%]')